#include <stdio.h>
#include <math.h>

#define TAIL 30

unsigned long fact[TAIL];

double e(void)
{
	int i;
	double sum = 0;
	for (i = 0; i < TAIL; i++) {
		sum += (double)1/fact[i];
	}
	return sum;
}

void calc_fact(void)
{
	int i;
	unsigned long f = 1;
	fact[0] = f;
	for (i = 1; i<TAIL; i++) {
		f *= i;
		fact[i] = f;
	}
}

int main(void)
{
#if 0
	double x = 1.0;
	while (1) {
		x += 2.0;
		if (x - (int)x > 0.000001)
			printf("ERROR: x=%f\n", x);
	}
#else	
	while (1) {
		double x;
		calc_fact();
		x = e();
		if (fabs(x - 2.718281) > 0.000001)
			printf("ERROR: x=%f\n", x);
	}
#endif
	return 0;
}
